﻿Imports System.Windows.Forms

Public Class AddNewPDialog

    Enum enumPType
        eString = 0
        eBool = 1
        eDouble = 2
        eDate = 3
    End Enum

    Private oOption As enumPType = enumPType.eString


    Private oUserPropertySet As Inventor.PropertySet
    Private PropID As Long = 0

    Public Sub getUserPropertySet(ByVal oUSet As Inventor.PropertySet)


        '获得缺省的自定义特性集
        oUserPropertySet = oUSet

        '获取最大PropID
        Dim oP As Inventor.Property
        For Each oP In oUserPropertySet
            If oP.PropId > PropID Then
                PropID = oP.PropId
            End If
        Next

        '可接受的PropID范围是: 2 ~ 254 , 256 ~ 0x80000000
        If PropID < 2 Then
            PropID = 2
        End If
    End Sub
    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click

        If PropertyName.Text = "" Then
            MsgBox("请输入新特性的名字！")
            Exit Sub
        End If

        '注意：新特性的名和PropID是唯一的，如果同名，Add 会失败
        Try
            PropID += 1 
            Select Case oOption
                Case enumPType.eString
                    oUserPropertySet.Add(StringP.Text, PropertyName.Text, PropID)
                Case enumPType.eBool
                    oUserPropertySet.Add(BoolP.Checked, PropertyName.Text, PropID)
                Case enumPType.eDouble
                    oUserPropertySet.Add(Convert.ToDouble(DoubleP.Text), PropertyName.Text, PropID)
                Case enumPType.eDate
                    oUserPropertySet.Add(DateTimeP.Value, PropertyName.Text, PropID)

            End Select
        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub AddNewPDialog_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        StringRadioButton.Checked = True
    End Sub

    Private Sub StringRadioButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StringRadioButton.Click
        oOption = enumPType.eString
    End Sub

    Private Sub BoolRadioButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BoolRadioButton.Click
        oOption = enumPType.eBool
    End Sub

    Private Sub DoubleRadioButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DoubleRadioButton.Click
        oOption = enumPType.eDouble
    End Sub

    Private Sub DateRadioButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DateRadioButton.Click
        oOption = enumPType.eDate
    End Sub
 
End Class
