﻿Imports Inventor
Imports stdole
Imports Microsoft.VisualBasic
Imports Microsoft.VisualBasic.Compatibility


Public Class Form1

    Private isApprentice As Boolean = False

    Private oApprenticeApp As Inventor.ApprenticeServerComponent
    Private oApprenticeDoc As Inventor.ApprenticeServerDocument

    Private Sub ButtonOpenDoc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOpenDoc.Click
        '打开文档
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            oApprenticeDoc = oApprenticeApp.Open(OpenFileDialog1.FileName)
            ListiProperties()
            Label1.Text = "当前打开文档   " & OpenFileDialog1.FileName
        End If
    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '获得学徒服务器application
        oApprenticeApp = New Inventor.ApprenticeServerComponent()
        Label1.Text = "没有文档打开"

    End Sub

    Private Sub SaveAllChange_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveAllChange.Click
        If oApprenticeDoc Is Nothing Then
            MsgBox("没有文档打开！")
            Exit Sub
        End If

        oApprenticeDoc.PropertySets.FlushToFile()

    End Sub

    Private Sub Form1_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        oApprenticeApp = Nothing
    End Sub

    Private Sub AccessAndChangeAuthor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AccessAndChangeAuthor.Click

        If oApprenticeDoc Is Nothing Then
            MsgBox("没有文档打开！")
            Exit Sub
        End If

        Dim oDTProps As PropertySet = oApprenticeDoc.PropertySets.Item("Design Tracking Properties")

        Dim oDesignerProp As Inventor.Property = oDTProps.ItemByPropId(Inventor.PropertiesForDesignTrackingPropertiesEnum.kDesignerDesignTrackingProperties)

        oDesignerProp = oDTProps.Item("Designer")

        Debug.Print(oDesignerProp.DisplayName & " = " & oDesignerProp.Value)

        oDesignerProp.Value = "欧特克"


        ListiProperties()
    End Sub

    Private Sub ListiProperties()

        If oApprenticeDoc Is Nothing Then
            Exit Sub
        End If
        Dim oPropertySets As Inventor.PropertySets = oApprenticeDoc.PropertySets
        Dim oPropertySet As Inventor.PropertySet
        Dim oProperty As Inventor.Property
         
        DataGridView1.Columns.Clear()
        DataGridView1.Rows.Clear()

        Dim oUserPSCount As Integer = 1
        Dim oColumnCount As Integer = 0

        For Each oPropertySet In oPropertySets

            If oPropertySet.Name = "Inventor Summary Information" Then
                DataGridView1.Columns.Add("SI", "概要特性")
            ElseIf oPropertySet.Name = "Inventor Document Summary Information" Then
                DataGridView1.Columns.Add("DSI", "文档概要特性")
            ElseIf oPropertySet.Name = "Design Tracking Properties" Then
                DataGridView1.Columns.Add("DTP", "设计跟踪特性")
            ElseIf oPropertySet.Name = "Inventor User Defined Properties" Then
                DataGridView1.Columns.Add("UDP", "缺省自定义特性")
            Else
                DataGridView1.Columns.Add("USER" & oUserPSCount, "自定义特性 " & oUserPSCount)
                oUserPSCount += 1
            End If
 
            Dim oCurrentR As Integer = 0
            For Each oProperty In oPropertySet

                If oCurrentR = DataGridView1.Rows.Count - 1 Then '需要添加一行
                    oCurrentR = DataGridView1.Rows.Add()
                End If

                If oPropertySet.Name = "Inventor Summary Information" And oProperty.Name = "Thumbnail" Then
                    DataGridView1(oColumnCount, oCurrentR).Value = "名：" & oProperty.Name & "   值： " & "**是位图**"
                    PictureBox1.Image = VB6.Support.IPictureDispToImage(oProperty.Value)
                Else
                    DataGridView1(oColumnCount, oCurrentR).Value = "名：" & oProperty.Name & "   值： " & oProperty.Value

                End If

                oCurrentR += 1

            Next

            oColumnCount += 1
        Next


    End Sub

    Private Sub AccessThumbnail_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AccessThumbnail.Click

        If oApprenticeDoc Is Nothing Then
            MsgBox("没有文档打开！")
            Exit Sub
        End If

        Dim oPropertySets As Inventor.PropertySets = oApprenticeDoc.PropertySets

        '获取概要信息特性集
        Dim oPropertySet As Inventor.PropertySet = oPropertySets("{F29F85E0-4FF9-1068-AB91-08002B27B3D9}")

        ' 获取缩略图特性
        Dim oProperty As Inventor.Property = oPropertySet.ItemByPropId(17)

        Dim oDisp As stdole.IPictureDisp
        oDisp = oProperty.Value

        Dim oB As Object = oDisp
        'oProperty.Value = oB

        PictureBox1.Image = VB6.IPictureDispToImage(oDisp)
        PictureBox1.Image.Save("C:\Temp\ThumbnailOld.bmp")

        '学徒服务器目前不支持修改缩略图特性 
    End Sub
 


    Private Sub CreatePropertySet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreatePropertySet.Click

        If oApprenticeDoc Is Nothing Then
            MsgBox("没有文档打开！")
            Exit Sub
        End If

        Try
            Dim oPropertySets As Inventor.PropertySets = oApprenticeDoc.PropertySets

            '使用 VS的GUID生成器得到一个GUID。作为新特性集的内部名
            Dim oNewPropertySet As Inventor.PropertySet = oPropertySets.Add("我的特性集", "{5042C5BE-922D-4768-905E-A2B0145F0F17}")

            '添加新特性
            Dim oPDialog As AddNewPDialog = New AddNewPDialog
            AddNewPDialog.getUserPropertySet(oNewPropertySet)
            AddNewPDialog.ShowDialog()
        Catch ex As Exception
            MsgBox(ex.ToString())
        End Try


        ListiProperties()

    End Sub

    Private Sub AddPropertyToUserPS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddPropertyToUserPS.Click

        If oApprenticeDoc Is Nothing Then
            MsgBox("没有文档打开！")
            Exit Sub
        End If

        Dim oPDialog As AddNewPDialog = New AddNewPDialog
        AddNewPDialog.getUserPropertySet(oApprenticeDoc.PropertySets("{D5CDD505-2E9C-101B-9397-08002B2CF9AE}"))
        AddNewPDialog.ShowDialog()
         

        ListiProperties()
    End Sub

End Class
